package net.knarcraft.bookswithoutborders.command;

import net.knarcraft.bookswithoutborders.BooksWithoutBorders;
import net.knarcraft.bookswithoutborders.state.EncryptionStyle;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.meta.BookMeta;

import java.util.List;

/**
 * Command executor for the group encrypt command
 */
public class CommandGroupEncrypt extends CommandEncrypt implements CommandExecutor {

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        BookMeta bookMetadata = performPreChecks(sender, args, 2,
                "You must specify a group name and key to encrypt a book!");

        if (bookMetadata == null) {
            return false;
        }

        //Check if book is already group encrypted
        List<String> lore = bookMetadata.getLore();
        if (bookMetadata.hasLore() && lore != null && lore.get(0).contains(" encrypted]")) {
            BooksWithoutBorders.sendErrorMessage(sender, "Book is already group encrypted!");
            return false;
        }

        EncryptionStyle encryptionStyle = args.length == 3 ? EncryptionStyle.getFromString(args[2]) : EncryptionStyle.SUBSTITUTION;
        return encryptBook(encryptionStyle, (Player) sender, args[1], args[0]);
    }

}
