package net.knarcraft.bookswithoutborders.state;

/**
 * This enum represents the possible states for players holding books
 */
public enum BookHoldingState {

    /**
     * The player is holding one signed book in each hand
     */
    SIGNED_BOTH_HANDS,

    /**
     * The player is holding one unsigned book in each hand
     */
    UNSIGNED_BOTH_HANDS,

    /**
     * The player is holding one signed book in their main hand
     */
    SIGNED_MAIN_HAND,

    /**
     * The player is holding one unsigned book in their main hand
     */
    UNSIGNED_MAIN_HAND,

    /**
     * The player is holding one signed book in their off hand
     */
    SIGNED_OFF_HAND,

    /**
     * The player is holding one unsigned book in their off hand
     */
    UNSIGNED_OFF_HAND,

    /**
     * The player is holding one signed book in their main hand and one unsigned book in their off hand
     */
    SIGNED_MAIN_HAND_UNSIGNED_OFF_HAND,

    /**
     * The player is holding one unsigned book in their main hand and one signed book in their off hand
     */
    UNSIGNED_MAIN_HAND_SIGNED_OFF_HAND,

    /**
     * The player is not holding any books
     */
    NONE

}
